'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _VerticalStep = require('./VerticalStep');

var _VerticalStep2 = _interopRequireDefault(_VerticalStep);

var _FlowStepStatus = require('./FlowStepStatus');

var _FlowStepStatus2 = _interopRequireDefault(_FlowStepStatus);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SCROLL_DELAY_MILLIS = 50;

/**
 * Visual/logic component that defines an individual step of a multi-step workflow.
 * Intended to be used within a MultiStepFlow component.
 * Hides all content except for the title until the step becomes active.
 */

var FlowStep = function (_React$Component) {
  _inherits(FlowStep, _React$Component);

  function FlowStep() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, FlowStep);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = FlowStep.__proto__ || Object.getPrototypeOf(FlowStep)).call.apply(_ref, [this].concat(args))), _this), _this.scrollTimeoutId = null, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(FlowStep, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this._adjustScrolling({}, this.props);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      this._adjustScrolling(this.props, nextProps);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this._cleanup();
    }
  }, {
    key: '_bindStep',
    value: function _bindStep(step) {
      this.step = step;
    }
  }, {
    key: '_cleanup',
    value: function _cleanup() {
      if (this.scrollTimeoutId) {
        clearTimeout(this.scrollTimeoutId);
        this.scrollTimeoutId = 0;
      }
    }
  }, {
    key: '_adjustScrolling',
    value: function _adjustScrolling(oldProps, nextProps) {
      var _this2 = this;

      if (!nextProps.scrollOnActive) {
        return;
      }

      // only scroll if we've become active for the first time
      if (nextProps.status === _FlowStepStatus2.default.ACTIVE && nextProps.status !== oldProps.status) {
        this._cleanup();

        setTimeout(function () {
          if (_this2.step) {
            _this2.step.scrollIntoView();
          }
        }, SCROLL_DELAY_MILLIS);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this3 = this;

      var props = this.props;

      var percentage = props.loading ? 101 : props.percentage;
      var status = props.error ? _FlowStepStatus2.default.ERROR : props.status;

      return _react2.default.createElement(
        _VerticalStep2.default,
        {
          className: props.className,
          status: status,
          percentage: percentage,
          isLastStep: props.isLastStep
        },
        _react2.default.createElement(
          'div',
          { ref: function ref(step) {
              return _this3._bindStep(step);
            } },
          _react2.default.createElement(
            'h1',
            null,
            props.title
          ),
          props.status !== _FlowStepStatus2.default.INCOMPLETE && _react2.default.createElement(
            'fieldset',
            { disabled: props.disabled },
            props.children
          )
        )
      );
    }
  }]);

  return FlowStep;
}(_react2.default.Component);

exports.default = FlowStep;


FlowStep.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  title: _propTypes2.default.string,
  status: _propTypes2.default.string,
  percentage: _propTypes2.default.number,
  disabled: _propTypes2.default.bool,
  loading: _propTypes2.default.bool,
  error: _propTypes2.default.bool,
  scrollOnActive: _propTypes2.default.bool,
  isLastStep: _propTypes2.default.bool
};

FlowStep.defaultProps = {
  className: '',
  scrollOnActive: true
};