'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _FlowStepStatus = require('./FlowStepStatus');

var _FlowStepStatus2 = _interopRequireDefault(_FlowStepStatus);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Used to create a multi-step workflow with one or more FlowStep children.
 * Handles navigating forward through the flow and updating the state of each step.
 */
var MultiStepFlow = function (_React$Component) {
  _inherits(MultiStepFlow, _React$Component);

  function MultiStepFlow() {
    _classCallCheck(this, MultiStepFlow);

    return _possibleConstructorReturn(this, (MultiStepFlow.__proto__ || Object.getPrototypeOf(MultiStepFlow)).apply(this, arguments));
  }

  _createClass(MultiStepFlow, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var extraClass = this.props.className || '';

      return _react2.default.createElement(
        'div',
        { className: 'multi-step-flow-component ' + extraClass },
        _react2.default.Children.map(this.props.children, function (child, index) {
          var activeIndex = _this2.props.activeIndex;

          var status = _FlowStepStatus2.default.INCOMPLETE;

          if (index < activeIndex) {
            status = _FlowStepStatus2.default.COMPLETE;
          } else if (index === activeIndex) {
            status = _FlowStepStatus2.default.ACTIVE;
          }

          var isLastStep = index === _this2.props.children.length - 1;
          var extraProps = {
            status: status,
            isLastStep: isLastStep
          };

          return _react2.default.cloneElement(child, extraProps);
        })
      );
    }
  }]);

  return MultiStepFlow;
}(_react2.default.Component);

exports.default = MultiStepFlow;


MultiStepFlow.propTypes = {
  className: _propTypes2.default.string,
  children: _propTypes2.default.node,
  activeIndex: _propTypes2.default.number,
  onCompleteFlow: _propTypes2.default.func
};

MultiStepFlow.defaultProps = {
  activeIndex: 0
};