'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.StepsRenderer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _class;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _mobxReact = require('mobx-react');

var _logging = require('@jenkins-cd/logging');

var logging = _interopRequireWildcard(_logging);

var _MultiStepFlow = require('./MultiStepFlow');

var _MultiStepFlow2 = _interopRequireDefault(_MultiStepFlow);

var _FlowStep = require('./FlowStep');

var _FlowStep2 = _interopRequireDefault(_FlowStep);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var logger = logging.logger('react-flow.Renderer');

var StepsRenderer = exports.StepsRenderer = (0, _mobxReact.observer)(_class = function (_Component) {
    _inherits(StepsRenderer, _Component);

    function StepsRenderer() {
        _classCallCheck(this, StepsRenderer);

        return _possibleConstructorReturn(this, (StepsRenderer.__proto__ || Object.getPrototypeOf(StepsRenderer)).apply(this, arguments));
    }

    _createClass(StepsRenderer, [{
        key: 'render',
        value: function render() {
            var _this2 = this;

            // create Step elements from the steps
            var steps = this.props.flowManager.steps.map(function (step) {
                return step.stepElement;
            });
            // create Step elements for each "placeholder" text and
            var placeholderSteps = this.props.flowManager.placeholders.map(function (text) {
                return _react2.default.createElement(_FlowStep2.default, { title: text });
            });
            // then combine with the actual rendered steps
            var allSteps = [].concat(steps, placeholderSteps);

            return _react2.default.createElement(
                _MultiStepFlow2.default,
                {
                    className: 'creation-steps', activeIndex: this.props.flowManager.activeIndex
                },
                _react2.default.Children.map(allSteps, function (child) {
                    return _react2.default.cloneElement(child, _this2.props);
                })
            );
        }
    }]);

    return StepsRenderer;
}(_react.Component)) || _class;

StepsRenderer.propTypes = {
    flowManager: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.object])
};

exports.default = StepsRenderer;