'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = VerticalStep;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _StepIndicator = require('./StepIndicator');

var _StepIndicator2 = _interopRequireDefault(_StepIndicator);

var _FlowStepStatus = require('./FlowStepStatus');

var _FlowStepStatus2 = _interopRequireDefault(_FlowStepStatus);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Visual component that displays a progress indicator along with its children.
 * These components are intended to be stacked vertically.
 * Status / progress indicator displayed on left; children display on the right.
 */
function VerticalStep(props) {
  var classNames = ((props.status || '') + ' ' + (props.className || '') + ' ' + (props.isLastStep ? 'last-step' : '')).trim();

  return _react2.default.createElement(
    'div',
    { className: 'vertical-step-component ' + classNames },
    _react2.default.createElement(
      'div',
      { className: 'step-progress' },
      _react2.default.createElement('div', { className: 'step-stroke-top' }),
      _react2.default.createElement(_StepIndicator2.default, { status: props.status, percentage: props.percentage }),
      _react2.default.createElement('div', { className: 'step-stroke-bottom' })
    ),
    _react2.default.createElement(
      'div',
      { className: 'step-content' },
      props.children
    )
  );
}

VerticalStep.propTypes = {
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  isLastStep: _propTypes2.default.bool,
  status: _propTypes2.default.oneOf(_FlowStepStatus2.default.values()),
  percentage: _propTypes2.default.number
};

VerticalStep.defaultProps = {
  status: 'incomplete',
  percentage: -1
};